"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _v = _interopRequireDefault(require("uuid/v4"));

var _bluebird = _interopRequireDefault(require("bluebird"));

var _serializeError = _interopRequireDefault(require("serialize-error"));

var _es6Map = _interopRequireDefault(require("es6-map"));

var _electron = require("electron");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

// eslint-disable-line
var PromiseIpcBase =
/*#__PURE__*/
function () {
  function PromiseIpcBase(opts, eventEmitter) {
    _classCallCheck(this, PromiseIpcBase);

    if (opts) {
      this.maxTimeoutMs = opts.maxTimeoutMs;
    } // either ipcRenderer or ipcMain


    this.eventEmitter = eventEmitter;
    this.routeListenerMap = new _es6Map.default();
    this.listenerMap = new _es6Map.default();
  }

  _createClass(PromiseIpcBase, [{
    key: "send",
    value: function send(route, sender) {
      var _this = this;

      for (var _len = arguments.length, dataArgs = new Array(_len > 2 ? _len - 2 : 0), _key = 2; _key < _len; _key++) {
        dataArgs[_key - 2] = arguments[_key];
      }

      return new _bluebird.default(function (resolve, reject) {
        var replyChannel = "".concat(route, "#").concat((0, _v.default)());
        var timeout;
        var didTimeOut = false; // ipcRenderer will send a message back to replyChannel when it finishes calculating

        _this.eventEmitter.once(replyChannel, function (event, status, returnData) {
          clearTimeout(timeout);

          if (didTimeOut) {
            return null;
          }

          switch (status) {
            case 'success':
              return resolve(returnData);

            case 'failure':
              return reject(returnData);

            default:
              return reject(new Error("Unexpected IPC call status \"".concat(status, "\" in ").concat(route)));
          }
        });

        sender.send.apply(sender, [route, replyChannel].concat(dataArgs));

        if (_this.maxTimeoutMs) {
          timeout = setTimeout(function () {
            didTimeOut = true;
            reject(new Error("".concat(route, " timed out.")));
          }, _this.maxTimeoutMs);
        }
      });
    }
  }, {
    key: "on",
    value: function on(route, listener) {
      var prevListener = this.routeListenerMap.get(route); // If listener has already been added for this route, don't add it again.

      if (prevListener === listener) {
        return this;
      } // Only one listener may be active for a given route.
      // If two are active promises it won't work correctly - that's a race condition.


      if (this.routeListenerMap.has(route)) {
        this.off(route, prevListener);
      } // This function _wraps_ the listener argument. We maintain a map of
      // listener -> wrapped listener in order to implement #off().


      var wrappedListener = function wrappedListener(event, replyChannel) {
        for (var _len2 = arguments.length, dataArgs = new Array(_len2 > 2 ? _len2 - 2 : 0), _key2 = 2; _key2 < _len2; _key2++) {
          dataArgs[_key2 - 2] = arguments[_key2];
        }

        // Chaining off of Promise.resolve() means that listener can return a promise, or return
        // synchronously -- it can even throw. The end result will still be handled promise-like.
        _bluebird.default.resolve().then(function () {
          return listener.apply(void 0, dataArgs.concat([event]));
        }).then(function (results) {
          event.sender.send(replyChannel, 'success', results);
        }).catch(function (e) {
          event.sender.send(replyChannel, 'failure', (0, _serializeError.default)(e));
        });
      };

      this.routeListenerMap.set(route, listener);
      this.listenerMap.set(listener, wrappedListener);
      this.eventEmitter.on(route, wrappedListener);
      return this;
    }
  }, {
    key: "off",
    value: function off(route, listener) {
      var registeredListener = this.routeListenerMap.get(route);

      if (listener && listener !== registeredListener) {
        return; // trying to remove the wrong listener, so do nothing.
      }

      var wrappedListener = this.listenerMap.get(registeredListener);
      this.eventEmitter.removeListener(route, wrappedListener);
      this.listenerMap.delete(registeredListener);
      this.routeListenerMap.delete(route);
    }
  }, {
    key: "removeListener",
    value: function removeListener(route, listener) {
      this.off(route, listener);
    }
  }]);

  return PromiseIpcBase;
}();

exports.default = PromiseIpcBase;
//# sourceMappingURL=base.js.map